from dataclasses import dataclass
from typing import Self


@dataclass
class CollisionRubble:
    cars: set[str]

    def __eq__(self, other: object) -> bool:
        if not isinstance(other, CollisionRubble):
            return NotImplemented

        return self.cars == other.cars

    def __str__(self) -> str:
        return f"Collision Rubble [({', '.join(sorted(self.cars))})]"

    @classmethod
    def from_adding_cars_to_rubble(
        cls, collision_rubble: Self, cars: list[str]
    ) -> Self:
        return cls(collision_rubble.cars.union(cars))
