from enum import StrEnum


class Direction(StrEnum):
    NORTH = "N"
    EAST = "E"
    SOUTH = "S"
    WEST = "W"


class Command(StrEnum):
    LEFT = "L"
    RIGHT = "R"
    FORWARD = "F"


class CollisionType(StrEnum):
    # collisions from cars colliding with eachother
    COLLISION_AT_OUTSET = "collision because of multiple cars being placed at the same position at simulation outset"
    COLLISION_AT_EMPTY_POSITION = "collision because of multiple cars moving towards a previously unoccupied position in the same simulation step"
    COLLISION_WITH_STATIONARY_CAR = "collision because of one or more cars moving towards a position having a stationary car in the same simulation step"

    # collisions from cars colliding with pre-existing collisions
    COLLISION_WITH_PRE_EXISTING_RUBBLE = "collision because of one or more cars moving towards a position having a pre-existing collision rubble in the same simulation step"
